# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/LoadCarrierWithFillingLevel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg
import std_msgs.msg

class LoadCarrierWithFillingLevel(genpy.Message):
  _md5sum = "8df51d8f73786bbb32f9d962edc85ce9"
  _type = "rc_pick_client/LoadCarrierWithFillingLevel"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This represents a detected load carrier with it's filling level

string id

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

geometry_msgs/PoseStamped pose

# True if a detected load carrier is overfilled. Ignored on setting load carrier.
bool overfilled

# Filling level of the whole load carrier
CellFillingLevel overall_filling_level

# Filling level of each load carrier cell
CellFillingLevel[] cells_filling_levels

GridSize filling_level_cell_count

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/CellFillingLevel
# Dimensions of the 2D cell in meters
Rectangle cell_size

# Position of the cell center in meters (either in camera or external pose frame)
# The z-coordinate is on the level of the load carrier rim
geometry_msgs/Point cell_position

# Filling level of the cell in percent (100% represents a full cell)
RangeValue level_in_percent

# Free space of the cell in meters (how much space is left until the cell is full)
RangeValue level_free_in_meters

# Represents the percentage of valid pixels in this cell. Between 0 and 1 
float64 coverage

================================================================================
MSG: rc_pick_client/RangeValue
float64 min
float64 max
float64 mean

================================================================================
MSG: rc_pick_client/GridSize
uint32 x
uint32 y
"""
  __slots__ = ['id','outer_dimensions','inner_dimensions','rim_thickness','pose','overfilled','overall_filling_level','cells_filling_levels','filling_level_cell_count']
  _slot_types = ['string','rc_pick_client/Box','rc_pick_client/Box','rc_pick_client/Rectangle','geometry_msgs/PoseStamped','bool','rc_pick_client/CellFillingLevel','rc_pick_client/CellFillingLevel[]','rc_pick_client/GridSize']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       id,outer_dimensions,inner_dimensions,rim_thickness,pose,overfilled,overall_filling_level,cells_filling_levels,filling_level_cell_count

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(LoadCarrierWithFillingLevel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.id is None:
        self.id = ''
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_pick_client.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_pick_client.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_pick_client.msg.Rectangle()
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.overfilled is None:
        self.overfilled = False
      if self.overall_filling_level is None:
        self.overall_filling_level = rc_pick_client.msg.CellFillingLevel()
      if self.cells_filling_levels is None:
        self.cells_filling_levels = []
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_pick_client.msg.GridSize()
    else:
      self.id = ''
      self.outer_dimensions = rc_pick_client.msg.Box()
      self.inner_dimensions = rc_pick_client.msg.Box()
      self.rim_thickness = rc_pick_client.msg.Rectangle()
      self.pose = geometry_msgs.msg.PoseStamped()
      self.overfilled = False
      self.overall_filling_level = rc_pick_client.msg.CellFillingLevel()
      self.cells_filling_levels = []
      self.filling_level_cell_count = rc_pick_client.msg.GridSize()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_8d3I().pack(_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB12d().pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.overfilled, _x.overall_filling_level.cell_size.x, _x.overall_filling_level.cell_size.y, _x.overall_filling_level.cell_position.x, _x.overall_filling_level.cell_position.y, _x.overall_filling_level.cell_position.z, _x.overall_filling_level.level_in_percent.min, _x.overall_filling_level.level_in_percent.max, _x.overall_filling_level.level_in_percent.mean, _x.overall_filling_level.level_free_in_meters.min, _x.overall_filling_level.level_free_in_meters.max, _x.overall_filling_level.level_free_in_meters.mean, _x.overall_filling_level.coverage))
      length = len(self.cells_filling_levels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cells_filling_levels:
        _v1 = val1.cell_size
        _x = _v1
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v2 = val1.cell_position
        _x = _v2
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v3 = val1.level_in_percent
        _x = _v3
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _v4 = val1.level_free_in_meters
        _x = _v4
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _x = val1.coverage
        buff.write(_get_struct_d().pack(_x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.filling_level_cell_count.x, _x.filling_level_cell_count.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_pick_client.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_pick_client.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_pick_client.msg.Rectangle()
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.overall_filling_level is None:
        self.overall_filling_level = rc_pick_client.msg.CellFillingLevel()
      if self.cells_filling_levels is None:
        self.cells_filling_levels = None
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_pick_client.msg.GridSize()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 76
      (_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _get_struct_8d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 153
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.overfilled, _x.overall_filling_level.cell_size.x, _x.overall_filling_level.cell_size.y, _x.overall_filling_level.cell_position.x, _x.overall_filling_level.cell_position.y, _x.overall_filling_level.cell_position.z, _x.overall_filling_level.level_in_percent.min, _x.overall_filling_level.level_in_percent.max, _x.overall_filling_level.level_in_percent.mean, _x.overall_filling_level.level_free_in_meters.min, _x.overall_filling_level.level_free_in_meters.max, _x.overall_filling_level.level_free_in_meters.mean, _x.overall_filling_level.coverage,) = _get_struct_7dB12d().unpack(str[start:end])
      self.overfilled = bool(self.overfilled)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cells_filling_levels = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.CellFillingLevel()
        _v5 = val1.cell_size
        _x = _v5
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v6 = val1.cell_position
        _x = _v6
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v7 = val1.level_in_percent
        _x = _v7
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        _v8 = val1.level_free_in_meters
        _x = _v8
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 8
        (val1.coverage,) = _get_struct_d().unpack(str[start:end])
        self.cells_filling_levels.append(val1)
      _x = self
      start = end
      end += 8
      (_x.filling_level_cell_count.x, _x.filling_level_cell_count.y,) = _get_struct_2I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_8d3I().pack(_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs))
      _x = self.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB12d().pack(_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.overfilled, _x.overall_filling_level.cell_size.x, _x.overall_filling_level.cell_size.y, _x.overall_filling_level.cell_position.x, _x.overall_filling_level.cell_position.y, _x.overall_filling_level.cell_position.z, _x.overall_filling_level.level_in_percent.min, _x.overall_filling_level.level_in_percent.max, _x.overall_filling_level.level_in_percent.mean, _x.overall_filling_level.level_free_in_meters.min, _x.overall_filling_level.level_free_in_meters.max, _x.overall_filling_level.level_free_in_meters.mean, _x.overall_filling_level.coverage))
      length = len(self.cells_filling_levels)
      buff.write(_struct_I.pack(length))
      for val1 in self.cells_filling_levels:
        _v9 = val1.cell_size
        _x = _v9
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v10 = val1.cell_position
        _x = _v10
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v11 = val1.level_in_percent
        _x = _v11
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _v12 = val1.level_free_in_meters
        _x = _v12
        buff.write(_get_struct_3d().pack(_x.min, _x.max, _x.mean))
        _x = val1.coverage
        buff.write(_get_struct_d().pack(_x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.filling_level_cell_count.x, _x.filling_level_cell_count.y))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.outer_dimensions is None:
        self.outer_dimensions = rc_pick_client.msg.Box()
      if self.inner_dimensions is None:
        self.inner_dimensions = rc_pick_client.msg.Box()
      if self.rim_thickness is None:
        self.rim_thickness = rc_pick_client.msg.Rectangle()
      if self.pose is None:
        self.pose = geometry_msgs.msg.PoseStamped()
      if self.overall_filling_level is None:
        self.overall_filling_level = rc_pick_client.msg.CellFillingLevel()
      if self.cells_filling_levels is None:
        self.cells_filling_levels = None
      if self.filling_level_cell_count is None:
        self.filling_level_cell_count = rc_pick_client.msg.GridSize()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.id = str[start:end]
      _x = self
      start = end
      end += 76
      (_x.outer_dimensions.x, _x.outer_dimensions.y, _x.outer_dimensions.z, _x.inner_dimensions.x, _x.inner_dimensions.y, _x.inner_dimensions.z, _x.rim_thickness.x, _x.rim_thickness.y, _x.pose.header.seq, _x.pose.header.stamp.secs, _x.pose.header.stamp.nsecs,) = _get_struct_8d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 153
      (_x.pose.pose.position.x, _x.pose.pose.position.y, _x.pose.pose.position.z, _x.pose.pose.orientation.x, _x.pose.pose.orientation.y, _x.pose.pose.orientation.z, _x.pose.pose.orientation.w, _x.overfilled, _x.overall_filling_level.cell_size.x, _x.overall_filling_level.cell_size.y, _x.overall_filling_level.cell_position.x, _x.overall_filling_level.cell_position.y, _x.overall_filling_level.cell_position.z, _x.overall_filling_level.level_in_percent.min, _x.overall_filling_level.level_in_percent.max, _x.overall_filling_level.level_in_percent.mean, _x.overall_filling_level.level_free_in_meters.min, _x.overall_filling_level.level_free_in_meters.max, _x.overall_filling_level.level_free_in_meters.mean, _x.overall_filling_level.coverage,) = _get_struct_7dB12d().unpack(str[start:end])
      self.overfilled = bool(self.overfilled)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.cells_filling_levels = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.CellFillingLevel()
        _v13 = val1.cell_size
        _x = _v13
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v14 = val1.cell_position
        _x = _v14
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v15 = val1.level_in_percent
        _x = _v15
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        _v16 = val1.level_free_in_meters
        _x = _v16
        start = end
        end += 24
        (_x.min, _x.max, _x.mean,) = _get_struct_3d().unpack(str[start:end])
        start = end
        end += 8
        (val1.coverage,) = _get_struct_d().unpack(str[start:end])
        self.cells_filling_levels.append(val1)
      _x = self
      start = end
      end += 8
      (_x.filling_level_cell_count.x, _x.filling_level_cell_count.y,) = _get_struct_2I().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
_struct_7dB12d = None
def _get_struct_7dB12d():
    global _struct_7dB12d
    if _struct_7dB12d is None:
        _struct_7dB12d = struct.Struct("<7dB12d")
    return _struct_7dB12d
_struct_8d3I = None
def _get_struct_8d3I():
    global _struct_8d3I
    if _struct_8d3I is None:
        _struct_8d3I = struct.Struct("<8d3I")
    return _struct_8d3I
_struct_d = None
def _get_struct_d():
    global _struct_d
    if _struct_d is None:
        _struct_d = struct.Struct("<d")
    return _struct_d
