# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/SetLoadCarrierRequest.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg
import std_msgs.msg

class SetLoadCarrierRequest(genpy.Message):
  _md5sum = "7524ca364d10bfecdeffd908a5b2f74b"
  _type = "rc_pick_client/SetLoadCarrierRequest"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """


LoadCarrier load_carrier


================================================================================
MSG: rc_pick_client/LoadCarrier
# This represents a load carrier by its geometry and its pose

string id

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

geometry_msgs/PoseStamped pose

# True if a detected load carrier is overfilled. Ignored on setting load carrier.
bool overfilled

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['load_carrier']
  _slot_types = ['rc_pick_client/LoadCarrier']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       load_carrier

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetLoadCarrierRequest, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.load_carrier is None:
        self.load_carrier = rc_pick_client.msg.LoadCarrier()
    else:
      self.load_carrier = rc_pick_client.msg.LoadCarrier()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.load_carrier.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_8d3I().pack(_x.load_carrier.outer_dimensions.x, _x.load_carrier.outer_dimensions.y, _x.load_carrier.outer_dimensions.z, _x.load_carrier.inner_dimensions.x, _x.load_carrier.inner_dimensions.y, _x.load_carrier.inner_dimensions.z, _x.load_carrier.rim_thickness.x, _x.load_carrier.rim_thickness.y, _x.load_carrier.pose.header.seq, _x.load_carrier.pose.header.stamp.secs, _x.load_carrier.pose.header.stamp.nsecs))
      _x = self.load_carrier.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB().pack(_x.load_carrier.pose.pose.position.x, _x.load_carrier.pose.pose.position.y, _x.load_carrier.pose.pose.position.z, _x.load_carrier.pose.pose.orientation.x, _x.load_carrier.pose.pose.orientation.y, _x.load_carrier.pose.pose.orientation.z, _x.load_carrier.pose.pose.orientation.w, _x.load_carrier.overfilled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier is None:
        self.load_carrier = rc_pick_client.msg.LoadCarrier()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier.id = str[start:end]
      _x = self
      start = end
      end += 76
      (_x.load_carrier.outer_dimensions.x, _x.load_carrier.outer_dimensions.y, _x.load_carrier.outer_dimensions.z, _x.load_carrier.inner_dimensions.x, _x.load_carrier.inner_dimensions.y, _x.load_carrier.inner_dimensions.z, _x.load_carrier.rim_thickness.x, _x.load_carrier.rim_thickness.y, _x.load_carrier.pose.header.seq, _x.load_carrier.pose.header.stamp.secs, _x.load_carrier.pose.header.stamp.nsecs,) = _get_struct_8d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.load_carrier.pose.pose.position.x, _x.load_carrier.pose.pose.position.y, _x.load_carrier.pose.pose.position.z, _x.load_carrier.pose.pose.orientation.x, _x.load_carrier.pose.pose.orientation.y, _x.load_carrier.pose.pose.orientation.z, _x.load_carrier.pose.pose.orientation.w, _x.load_carrier.overfilled,) = _get_struct_7dB().unpack(str[start:end])
      self.load_carrier.overfilled = bool(self.load_carrier.overfilled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.load_carrier.id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_8d3I().pack(_x.load_carrier.outer_dimensions.x, _x.load_carrier.outer_dimensions.y, _x.load_carrier.outer_dimensions.z, _x.load_carrier.inner_dimensions.x, _x.load_carrier.inner_dimensions.y, _x.load_carrier.inner_dimensions.z, _x.load_carrier.rim_thickness.x, _x.load_carrier.rim_thickness.y, _x.load_carrier.pose.header.seq, _x.load_carrier.pose.header.stamp.secs, _x.load_carrier.pose.header.stamp.nsecs))
      _x = self.load_carrier.pose.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7dB().pack(_x.load_carrier.pose.pose.position.x, _x.load_carrier.pose.pose.position.y, _x.load_carrier.pose.pose.position.z, _x.load_carrier.pose.pose.orientation.x, _x.load_carrier.pose.pose.orientation.y, _x.load_carrier.pose.pose.orientation.z, _x.load_carrier.pose.pose.orientation.w, _x.load_carrier.overfilled))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.load_carrier is None:
        self.load_carrier = rc_pick_client.msg.LoadCarrier()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier.id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier.id = str[start:end]
      _x = self
      start = end
      end += 76
      (_x.load_carrier.outer_dimensions.x, _x.load_carrier.outer_dimensions.y, _x.load_carrier.outer_dimensions.z, _x.load_carrier.inner_dimensions.x, _x.load_carrier.inner_dimensions.y, _x.load_carrier.inner_dimensions.z, _x.load_carrier.rim_thickness.x, _x.load_carrier.rim_thickness.y, _x.load_carrier.pose.header.seq, _x.load_carrier.pose.header.stamp.secs, _x.load_carrier.pose.header.stamp.nsecs,) = _get_struct_8d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier.pose.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.load_carrier.pose.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 57
      (_x.load_carrier.pose.pose.position.x, _x.load_carrier.pose.pose.position.y, _x.load_carrier.pose.pose.position.z, _x.load_carrier.pose.pose.orientation.x, _x.load_carrier.pose.pose.orientation.y, _x.load_carrier.pose.pose.orientation.z, _x.load_carrier.pose.pose.orientation.w, _x.load_carrier.overfilled,) = _get_struct_7dB().unpack(str[start:end])
      self.load_carrier.overfilled = bool(self.load_carrier.overfilled)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_7dB = None
def _get_struct_7dB():
    global _struct_7dB
    if _struct_7dB is None:
        _struct_7dB = struct.Struct("<7dB")
    return _struct_7dB
_struct_8d3I = None
def _get_struct_8d3I():
    global _struct_8d3I
    if _struct_8d3I is None:
        _struct_8d3I = struct.Struct("<8d3I")
    return _struct_8d3I
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/SetLoadCarrierResponse.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_common_msgs.msg

class SetLoadCarrierResponse(genpy.Message):
  _md5sum = "89940768eec602f7650f8f061383e0f9"
  _type = "rc_pick_client/SetLoadCarrierResponse"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """
rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['return_code']
  _slot_types = ['rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SetLoadCarrierResponse, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.return_code.value
      buff.write(_get_struct_h().pack(_x))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.return_code.message = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
class SetLoadCarrier(object):
  _type          = 'rc_pick_client/SetLoadCarrier'
  _md5sum = 'b61f2185d575e109c7c3678c2a0b5ecd'
  _request_class  = SetLoadCarrierRequest
  _response_class = SetLoadCarrierResponse
